# Place item in 24b and replace that item with item in 20b
# NOTE: This has to happen because I can't add a Slot:24b to the storage
item replace block ~ ~-0.25 ~ container.24 with minecraft:smithing_table
data modify storage better_smithing_table:smithing_table Items set from block ~ ~-0.25 ~ Items
data modify storage better_smithing_table:smithing_table Items[{Slot:24b}].id set from storage better_smithing_table:smithing_table Items[{Slot:20b}].id
data modify storage better_smithing_table:smithing_table Items[{Slot:24b}].components set from storage better_smithing_table:smithing_table Items[{Slot:20b}].components

# Check for netherite upgrade and update id of 24 in storage
execute if data storage better_smithing_table:smithing_table Items[{Slot:19b,id:"minecraft:netherite_upgrade_smithing_template"}] \
        if data storage better_smithing_table:smithing_table Items[{Slot:21b,id:"minecraft:netherite_ingot"}] \
        if items block ~ ~-0.25 ~ container.20 #better_smithing_table:diamond_tools_and_armor \
    run function better_smithing_table:blocks/smithing_table/upgrade_item/check_items_netherite_upgrade

# Change the output item data depending on upgrade, trim, and material
execute unless data storage better_smithing_table:smithing_table Items[{Slot:19b,id:"minecraft:netherite_upgrade_smithing_template"}] \
    run function better_smithing_table:blocks/smithing_table/pattern_check
execute unless data storage better_smithing_table:smithing_table Items[{Slot:19b,id:"minecraft:netherite_upgrade_smithing_template"}] \
    run function better_smithing_table:blocks/smithing_table/material_check

# Copy item to armor stand display
execute unless items block ~ ~-0.25 ~ container.20 #better_smithing_table:diamond_tools \
    run function better_smithing_table:blocks/smithing_table/armor_check
# Copy item to item display
execute if items block ~ ~-0.25 ~ container.20 #better_smithing_table:diamond_tools \
        as @e[type=minecraft:item_display,tag=better_smithing_table.tool_display,limit=1,sort=nearest] \
    run function better_smithing_table:blocks/smithing_table/armor_display/display_tool

execute unless score @s better_smithing_table.craft matches 1.. \
    run function better_smithing_table:blocks/smithing_table/check_wrong_armor_or_tool_for_upgrade

# Copy exact item to the output slot (preserves enchantments, name, etc, and adds the trim/upgrade)
execute if score @s better_smithing_table.craft matches 1 \
        unless items block ~ ~-0.25 ~ container.20 #better_smithing_table:diamond_tools \
        as @e[distance=..2,type=armor_stand,tag=better_smithing_table.armor_display,limit=1,sort=nearest] \
    run function better_smithing_table:blocks/smithing_table/set_item_output_armor
execute if score @s better_smithing_table.craft matches 1 \
        if items block ~ ~-0.25 ~ container.20 #better_smithing_table:diamond_tools \
        as @e[distance=..2,type=minecraft:item_display,tag=better_smithing_table.tool_display,limit=1,sort=nearest] \
    run function better_smithing_table:blocks/smithing_table/set_item_output_tool